#include "modelo.h"

double calculaMovimentoBase(double langle_up, double langle_lo, 
		double rangle_up, double rangle_lo){
	
   double result1, result2, first_result, second_result, 
   		radians_up, radians_lo ;

   radians_up = (PI*langle_up)/180.0 ;
   radians_lo = (PI*langle_lo-langle_up)/180.0 ;
   result1 = (ALTURA_COXA + 2*VIRILHA) * cos(radians_up) ;
   result2 = (ALTURA_CANELA + 2*(JOELHO+TORNOZELO)+ALTURA_PE)* cos(radians_lo);
   first_result = ALTURA_PERNA - (result1 + result2) ;

   radians_up = (PI*rangle_up)/180.0 ;
   radians_lo = (PI*rangle_lo-rangle_up)/180.0 ;
   result1 = (ALTURA_COXA + 2*VIRILHA) * cos(radians_up) ;
   result2 = (ALTURA_CANELA + 2*(JOELHO+TORNOZELO)+ALTURA_PE) * cos(radians_lo);
   second_result = ALTURA_PERNA - (result1 + result2) ;

   if (first_result <= second_result)
      return (- first_result) ;
   else
      return (- second_result) ;
}

void calcula_angulos(float dve, float dvd, float dje, float djd, float doe, float dod, float dce,
		float dcd, float dme, float dmd, float daq, float dat, float imp){
	dve = dve / quadros;
	dvd = dvd / quadros;
        dje = dje / quadros;
	djd = djd / quadros;
	doe = doe / quadros;
        dod = dod / quadros;
        dce = dce / quadros;
        dcd = dcd / quadros;
        dme = dme / quadros;
        dmd = dmd / quadros;
	daq = daq / quadros;
	dat = dat / quadros;

	caminhar_angulos[0][0] += dod;
        caminhar_angulos[0][1] += dcd;
        caminhar_angulos[0][2] += dmd;
	caminhar_angulos[0][3] += dvd;
        caminhar_angulos[0][4] += djd;
        caminhar_angulos[1][0] += doe;
        caminhar_angulos[1][1] += dce;
        caminhar_angulos[1][2] += dme;
        caminhar_angulos[1][3] += dve;
        caminhar_angulos[1][4] += dje;
        
	angulo_virilhaE  -= dve;
        angulo_joelhoE -= dje;
        angulo_virilhaD -= dvd;
	angulo_joelhoD -= djd;
	angulo_quadril -= daq;
	angulo_tronco -= dat;
	
	if(movimento == ANDAR)
		movimento_base = calculaMovimentoBase(angulo_virilhaE,
			angulo_joelhoE, angulo_virilhaD, angulo_joelhoD);
	else 
		movimento_base += imp / quadros;
}

void anima(){
   static int	zoom_fl = 0;
   float difVirilhaE,
       	 difVirilhaD,
      	 difJoelhoE,
      	 difJoelhoD,
	 difOmbroE,
	 difOmbroD,
	 difCotoveloE,
	 difCotoveloD,
	 difMaoE,
	 difMaoD,
	 difQuadril,
	 difTronco,
	 impulso = 0;

   if(movimento == ANDAR){
	   switch (frame_atual){
	      case 1 :
        	difVirilhaE 	= 15 ;
	        difVirilhaD 	= 5 ;
	        difJoelhoE 	= 15 ;
        	difJoelhoD 	= 5 ;
		difOmbroE 	= -10;
		difOmbroD 	= 10;
		difCotoveloE 	= -8;
		difCotoveloD 	= 8;
		difMaoE		= -10;
        	difMaoD		= 10;
		difQuadril 	= 15;
		difTronco 	= -15;
        	break ;
	      case 2 :
        	difVirilhaE 	= 20 ;
	        difVirilhaD 	= -65 ;
        	difJoelhoE 	= -15 ;
	        difJoelhoD 	= 85 ;
		difOmbroE 	= -10;
		difOmbroD 	= 10;
		difCotoveloE 	= -8;
		difCotoveloD 	= 8;
		difMaoE		= -10;
        	difMaoD		= 10;
		difQuadril 	= 15;
		difTronco 	= -15;
	        break ;
	      case 3 :
	        difVirilhaE 	= 5 ;
	        difVirilhaD 	= -25 ;
	        difJoelhoE 	= 10 ;
	        difJoelhoD 	= -40 ;
		difOmbroE 	= -10;
		difOmbroD 	= 10;
		difCotoveloE 	= -8;
		difCotoveloD 	= 8;
		difMaoE		= -10;
        	difMaoD		= 10;
		difQuadril 	= 15;
		difTronco 	= -15;
        	break ;
	      case 4 :
        	difVirilhaE 	= 20 ;
	        difVirilhaD 	= 25 ;
        	difJoelhoE 	= -10 ;
	        difJoelhoD 	= -50 ;
		difOmbroE 	= -10;
		difOmbroD 	= 10;
		difCotoveloE 	= -8;
		difCotoveloD 	= 8;
		difMaoE		= -10;
       		difMaoD		= 10;
		difQuadril 	= 15;
		difTronco 	= -15;
		break;
	      case 5 :
        	difVirilhaE 	= 5 ;
	        difVirilhaD 	= 15 ;
        	difJoelhoE 	= 5 ;
	        difJoelhoD 	= 15 ;
		difOmbroE 	= 10;
		difOmbroD 	= -10;
		difCotoveloE 	= 8;
		difCotoveloD 	= -8;
		difMaoE		= 10;
        	difMaoD		= -10;
		difQuadril 	= -15;
		difTronco 	= 15;
		break;
	      case 6 :
        	difVirilhaE 	= -65 ;
	        difVirilhaD 	= 20 ;
        	difJoelhoE 	= 85 ;
	        difJoelhoD 	= -15 ;
		difOmbroE 	= 10;
		difOmbroD 	= -10;
		difCotoveloE 	= 8;
		difCotoveloD 	= -8;
		difMaoE		= 10;
        	difMaoD		= -10;
		difQuadril 	= -15;
		difTronco 	= 15;
		break;	
	      case 7 :
        	difVirilhaE 	= -25 ;
	        difVirilhaD 	= 5 ;
        	difJoelhoE 	= -40 ;
	        difJoelhoD 	= 10 ;
		difOmbroE 	= 10;
		difOmbroD 	= -10;
		difCotoveloE 	= 8;
		difCotoveloD 	= -8;
		difMaoE		= 10;
        	difMaoD		= -10;
		difQuadril 	= -15;
		difTronco 	= 15;
		break;	
	      case 8 :
        	difVirilhaE 	= 25 ;
	        difVirilhaD 	= 20 ;
        	difJoelhoE 	= -50 ;
	        difJoelhoD 	= -10 ;
		difOmbroE 	= 10;
		difOmbroD 	= -10;
		difCotoveloE 	= 8;
		difCotoveloD 	= -8;
		difMaoE		= 10;
        	difMaoD		= -10;
		difQuadril 	= -15;
		difTronco 	= 15;
		break;	
	      default :
        	break ;
	   }
   } else {			// Corrida
	   switch (frame_atual){
	      case 1 :
        	difVirilhaE 	= 75 ;
	        difVirilhaD 	= -120 ;
	        difJoelhoE 	= -90 ;
        	difJoelhoD 	= 15 ;
		difOmbroE 	= 20;
		difOmbroD 	= -20;
		difCotoveloE 	= 10;
		difCotoveloD 	= -10;
		difMaoE		= 0;
        	difMaoD		= 0;
		difQuadril 	= -15;
		difTronco 	= 15;

		impulso = 0.25;

        	break ;
	      case 2 :
        	difVirilhaE 	= 15 ;
	        difVirilhaD 	= 30 ;
        	difJoelhoE 	= 10 ;
	        difJoelhoD 	= -95 ;
		difOmbroE 	= 20;
		difOmbroD 	= -20;
		difCotoveloE 	= 10;
		difCotoveloD 	= -10;
		difMaoE		= 0;
        	difMaoD		= 0;
		difQuadril 	= 15;
		difTronco 	= -15;

		impulso = 0.0;

	        break ;
	      case 3 :
	        difVirilhaE 	= -15 ;
	        difVirilhaD 	= 15 ;
	        difJoelhoE 	= 5 ;
	        difJoelhoD 	= 10 ;
		difOmbroE 	= -20;
		difOmbroD 	= 20;
		difCotoveloE 	= -10;
		difCotoveloD 	= 10;
		difMaoE		= 0;
        	difMaoD		= 0;
		difQuadril 	= 15;
		difTronco 	= -15;

		impulso = -0.25;

        	break ;
	      case 4 :
        	difVirilhaE 	= -15 ;
	        difVirilhaD 	= 15 ;
        	difJoelhoE 	= 75 ;
	        difJoelhoD 	= 70 ;
		difOmbroE 	= -20;
		difOmbroD 	= 20;
		difCotoveloE 	= -10;
		difCotoveloD 	= 10;
		difMaoE		= 0;
       		difMaoD		= 0;
		difQuadril 	= 15;
		difTronco 	= -15;

		impulso = 0.0;

		break;
	      case 5 :
        	difVirilhaE 	= -120 ;
	        difVirilhaD 	= 75 ;
        	difJoelhoE 	= 15 ;
	        difJoelhoD 	= -90 ;
		difOmbroE 	= -20;
		difOmbroD 	= 20;
		difCotoveloE 	= -10;
		difCotoveloD 	= 10;
		difMaoE		= 0;
        	difMaoD		= 0;
		difQuadril 	= 15;
		difTronco 	= -15;

		impulso = 0.25;

		break;
	      case 6 :
        	difVirilhaE 	= 30 ;
	        difVirilhaD 	= 15 ;
        	difJoelhoE 	= -95 ;
	        difJoelhoD 	= 10 ;
		difOmbroE 	= -20;
		difOmbroD 	= 20;
		difCotoveloE 	= -10;
		difCotoveloD 	= 10;
		difMaoE		= 0;
        	difMaoD		= 0;
		difQuadril 	= -15;
		difTronco 	= 15;

		impulso = 0.0;
		
		break;	
	      case 7 :
        	difVirilhaE 	= 15 ;
	        difVirilhaD 	= -15 ;
        	difJoelhoE 	= 10 ;
	        difJoelhoD 	= 5 ;
		difOmbroE 	= 20;
		difOmbroD 	= -20;
		difCotoveloE 	= 10;
		difCotoveloD 	= -10;
		difMaoE		= 0;
        	difMaoD		= 0;
		difQuadril 	= -15;
		difTronco 	= 15;

		impulso = -0.25;
		
		break;	
	      case 8 :
        	difVirilhaE 	= 15 ;
	        difVirilhaD 	= -15 ;
        	difJoelhoE 	= 70 ;
	        difJoelhoD 	= 75;
		difOmbroE 	= 20;
		difOmbroD 	= -20;
		difCotoveloE 	= 10;
		difCotoveloD 	= -10;
		difMaoE		= 0;
        	difMaoD		= 0;
		difQuadril 	= -15;
		difTronco 	= 15;

		impulso = 0.0;
		
		break;	
	      default :
        	break ;
	}
   }
   calcula_angulos(difVirilhaE, difVirilhaD, difJoelhoE, difJoelhoD, difOmbroE, difOmbroD, 
		   difCotoveloE, difCotoveloD, difMaoE, difMaoD, difQuadril, difTronco, impulso);
   quadro_atual-- ;
   if (quadro_atual == 0){
	if(++frame_atual == 9) frame_atual = 1 ;
	quadro_atual = (movimento == ANDAR ? QUADROS : QUADROS / 2.0);
   }
		   
   glutPostRedisplay() ;
}

void desenhaQuadrilPernas(void){
   glPushMatrix() ;
    glRotatef(angulo_quadril, 0.0, 1.0, 0.0);
    glTranslatef(0.0,movimento_base,0.0) ;
    desenhaQuadril(SOLIDO) ;
    glTranslatef(0.0,-ALTURA_QUADRIL*0.9,0.0) ;
    glPushMatrix() ;
     glTranslatef(LARGURA_TRONCO * 0.5,0.0,0.0) ;
     glRotatef(-angulo_quadril, 0.0, 1.0, 0.0);
     desenhaPerna(ESQUERDA,SOLIDO) ;
    glPopMatrix() ;
    glTranslatef(-LARGURA_TRONCO * 0.5,0.0,0.0) ;
    glRotatef(-angulo_quadril, 0.0, 1.0, 0.0);
    desenhaPerna(DIREITA,SOLIDO) ;
   glPopMatrix() ;
   
   glPushMatrix();
   glTranslatef(0.0, movimento_base + ALTURA_TRONCO, 0.2);
   
   desenhaTroncoBracos();
   glPopMatrix();
}


//================= Base(frame) ======================

void desenhaQuadril(int frame){
   glPushMatrix();
   glTranslatef(0.0, CINTURA * 0.75, CINTURA * 0.5);
   glRotatef(10, 1.0, 0.0, 0.0);
   glScalef(CINTURA, CINTURA * 1.5, CINTURA * 0.75) ;
   glColor3f(1.0,0.8,0);
   if (frame == ARAME)
      glutWireSphere(1.0, 20.0, 20.0) ;
   else
      glutSolidSphere(1.0, 20.0, 20.0) ;
   
   glPopMatrix();

   //nadegas
   glPushMatrix();
   glTranslatef(-LARGURA_TRONCO*0.25, 0.0, 0.0);
   glScalef(NADEGAS,NADEGAS,NADEGAS*0.9) ;
   if (frame == ARAME)
        glutWireSphere(1.0, 20.0, 20.0) ;
   else
        glutSolidSphere(1.0, 20.0, 20.0) ;
   glPopMatrix() ;
		     
   glPushMatrix();
   glTranslatef(LARGURA_TRONCO*0.25, 0.0, 0.0);
   glScalef(NADEGAS,NADEGAS,NADEGAS*0.9) ;
   if (frame == ARAME)
         glutWireSphere(1.0, 20.0, 20.0)  ;
   else
         glutSolidSphere(1.0, 20.0, 20.0) ;
   glPopMatrix() ;

}

void desenhaCoxa(int frame){
   glPushMatrix();
   glScalef(VIRILHA, VIRILHA, VIRILHA) ;
   glColor3f(1.0,0.8,0);
   if (frame == ARAME)
   	glutWireSphere(1.0,8,8) ;
   else
   	glutSolidSphere(1.0,8,8) ;
   glPopMatrix() ;
   glColor3f(1.0,0.8,0);
   glTranslatef(0.0,- ALTURA_COXA * 0.65, 0.0) ;
   glPushMatrix() ;
   glScalef(LARGURA_COXA,ALTURA_COXA,LARGURA_COXA) ;
   
   if (frame == ARAME)
   	glutWireSphere(1.0, 20.0, 20.0) ;
   else
	glutSolidSphere(1.0, 20.0, 20.0) ;
   glPopMatrix() ;
}

void desenhaCanela(int frame){
   glPushMatrix() ;
   glScalef(JOELHO,JOELHO,JOELHO) ;
   glColor3f(1.0,0.8,0);
   if (frame == ARAME)
   	glutWireSphere(1.0,8,8) ;
   else
      glutSolidSphere(1.0,8,8) ;
   glPopMatrix() ;
   glTranslatef(0.0,- ALTURA_CANELA * 0.80,0.0) ;
   glPushMatrix() ;
   glScalef(LARGURA_CANELA,ALTURA_CANELA,LARGURA_CANELA) ;
   glColor3f(1.0,0.8,0);
   if (frame == ARAME)
	glutWireSphere(1.0, 20.0, 20.0) ;
   else
	glutSolidSphere(1.0, 20.0, 20.0) ;
   glPopMatrix() ;
}

void desenhaPe(int frame){
   glPushMatrix() ;
   glScalef(TORNOZELO,TORNOZELO,TORNOZELO) ;
   glColor3f(1.0,0.8,0);
   if (frame == ARAME)
  	glutWireSphere(1.0, 20.0, 20.0) ;
   else
        glutSolidSphere(1.0, 20.0, 20.0) ;
   glPopMatrix() ;
   glTranslatef(0.0,- TORNOZELO * 2.0, LARGURA_PE * 0.8) ;
   glPushMatrix() ;
   glScalef(LARGURA_PE, ALTURA_PE, PE) ;
   glColor3f(1.0,0.8,0);
   if (frame == ARAME)
   	glutWireSphere(1.0, 20.0, 20.0) ;
   else
        glutSolidSphere(1.0, 20.0, 20.0) ;
   glPopMatrix() ;
}

void desenhaPerna(int side, int frame){
   glPushMatrix() ;
   glRotatef(caminhar_angulos[side][3],1.0,0.0,0.0) ;
   desenhaCoxa(frame) ;
   glTranslatef(0.0,- ALTURA_COXA,0.0) ;
   glRotatef(caminhar_angulos[side][4],1.0,0.0,0.0) ;
   desenhaCanela(frame) ;
   glTranslatef(0.0,- ALTURA_CANELA, 0.0) ;
   glRotatef(caminhar_angulos[side][5],1.0,0.0,0.0) ;
   desenhaPe(frame) ;
   glPopMatrix() ;
}

void desenhaTroncoBracos(){
   glPushMatrix();

    glRotatef(angulo_tronco, 0.0, 1.0, 0.0);
    desenhaTronco(SOLIDO);
    glTranslatef(0.0, ALTURA_TRONCO * 0.8, 0.0) ;

    glPushMatrix();
     glTranslatef(0.0, ALTURA_TRONCO * 0.15, 0.0) ;
     desenhaCabeca(SOLIDO) ;
    glPopMatrix() ;
   
    glPushMatrix();
     glTranslatef(LARGURA_TRONCO * 0.5, 0.0, 0.0) ;
//glRotatef(-angulo_quadril, 0.0, 1.0, 0.0);
     desenhaGrupoBraco(ESQUERDA, SOLIDO) ;
    glPopMatrix() ;
   
    glTranslatef(-LARGURA_TRONCO * 0.5, 0.0, 0.0) ;
//    glRotatef(-angulo_quadril, 0.0, 1.0, 0.0);
    desenhaGrupoBraco(DIREITA,SOLIDO) ;
   glPopMatrix() ;
}

void desenhaTronco(int frame){
	glPushMatrix();
	glScalef(LARGURA_TRONCO, ALTURA_TRONCO, TRONCO);
	glColor3f(1.0,0.8,0);
        if (frame == ARAME)
	        glutWireSphere(1.0, 20.0, 20.0);
	else
	        glutSolidSphere(1.0, 20.0, 20.0);
	glPopMatrix();
	//seios
	glPushMatrix();
	glTranslatef(-LARGURA_TRONCO * 0.5, (ALTURA_TRONCO * 0.33)+(-movimento_base*0.3), TRONCO * 0.5);
	glScalef(SEIOS, SEIOS, SEIOS);
	glColor3f(1.0,0.8,0);
	if (frame == ARAME)
               glutWireSphere(1.0, 20.0, 20.0);
	else
               glutSolidSphere(1.0, 20.0, 20.0);
	glPopMatrix();
        
	glPushMatrix();
        glTranslatef(LARGURA_TRONCO * 0.5, (ALTURA_TRONCO * 0.33)+(-movimento_base*0.3), TRONCO * 0.5);
        glScalef(SEIOS, SEIOS, SEIOS);
        glColor3f(1.0,0.8,0);
        if (frame == ARAME)
               glutWireSphere(1.0, 20.0, 20.0);
        else
               glutSolidSphere(1.0, 20.0, 20.0);
	glPopMatrix();
}

void desenhaGrupoBraco(int side, int frame){
   glPushMatrix() ;
    glRotatef(caminhar_angulos[side][0],1.0, 0.0, 0.0) ;
    desenhaBraco(side, frame) ;
    glTranslatef(0.0,-ALTURA_BRACO,0.0) ;
    glRotatef(caminhar_angulos[side][1], 1.0, 0.0, 0.0) ;
    desenhaAntebraco(frame) ;
    glTranslatef(0.0,- ALTURA_ANTEBRACO, 0.0) ;
    glRotatef(caminhar_angulos[side][2],1.0,0.0,0.0) ;
    desenhaMao(frame) ;
   glPopMatrix() ;
}

void desenhaBraco(int side, int frame){
	glPushMatrix();
	glColor3f(1.0,0.8,0);
	glScalef(LARGURA_OMBRO, ALTURA_OMBRO, OMBRO);
        if (frame == ARAME)
	        glutWireSphere(1.0, 20.0, 20.0);
	else
	        glutSolidSphere(1.0, 20.0, 20.0);
	glPopMatrix();
	
	if(side == DIREITA)
		glTranslatef(-LARGURA_OMBRO, ALTURA_TRONCO * -0.6, 0.0);
	else
		glTranslatef(LARGURA_OMBRO, ALTURA_TRONCO * -0.6, 0.0);
	glPushMatrix();
        glScalef(LARGURA_BRACO, ALTURA_BRACO, LARGURA_BRACO);
        if (frame == ARAME)
                glutWireSphere(1.0, 20.0, 20.0);
        else
                glutSolidSphere(1.0, 20.0, 20.0);

	glPopMatrix();
}	

void desenhaAntebraco(int frame){
	glPushMatrix();
	glColor3f(1.0,0.8,0);
	glScalef(COTOVELO, COTOVELO, COTOVELO);
        if (frame == ARAME)
                glutWireSphere(1.0, 20.0, 20.0);
        else
                glutSolidSphere(1.0, 20.0, 20.0);
	glPopMatrix();

        glTranslatef(0.0, -ALTURA_ANTEBRACO * 0.75, 0.0);
        glPushMatrix();
        glScalef(LARGURA_ANTEBRACO, ALTURA_ANTEBRACO, LARGURA_ANTEBRACO);
        if (frame == ARAME)
                glutWireSphere(1.0, 20.0, 20.0);
        else
                glutSolidSphere(1.0, 20.0, 20.0);
	glPopMatrix();
}

void desenhaMao(int frame){
        glPushMatrix();
        glColor3f(1.0,0.8,0);
	glTranslatef(0.0, -ALTURA_MAO * 0.75, 0.0);
        glScalef(LARGURA_MAO, ALTURA_MAO, MAO);
	if (frame == ARAME)
                glutWireSphere(1.0, 20.0, 20.0);
        else
                glutSolidSphere(1.0, 20.0, 20.0);
        glPopMatrix();
}

void desenhaCabeca(int frame){
        glPushMatrix();
        glColor3f(1.0,0.8,0);
	glTranslatef(0.0, PESCOCO, 0.0);
        glScalef(PESCOCO, PESCOCO*1.5, PESCOCO*0.75);
	if (frame == ARAME)
                glutWireSphere(1.0, 20.0, 20.0);
        else
                glutSolidSphere(1.0, 20.0, 20.0);
        glPopMatrix();

	glTranslatef(0.0, ALTURA_CABECA*1.25, 0.0);
        glPushMatrix();
	glScalef(LARGURA_CABECA, ALTURA_CABECA, LARGURA_CABECA);
	if (frame == ARAME)
                glutWireSphere(1.0, 20.0, 20.0);
        else
                glutSolidSphere(1.0, 20.0, 20.0);
        glPopMatrix();
}
