#include <GL/glut.h>
#include <stdio.h>
#include <math.h>

#ifndef PI
#define PI 3.1415
#endif

#define ALTURA_PERNA		ALTURA_COXA + ALTURA_CANELA + ALTURA_PE + 2 *(TORNOZELO+VIRILHA+JOELHO)

//QUADRIL
#define LARGURA_QUADRIL         ALTURA_TRONCO * 0.5 * 1.5	//LARGURA_TRONCO * 1.5
#define ALTURA_QUADRIL          (NADEGAS + CINTURA)*0.6
#define CINTURA                 LARGURA_QUADRIL / 2.5
#define NADEGAS                 LARGURA_QUADRIL / 2.0
//COXA
#define VIRILHA                 0.1
#define ALTURA_COXA		ALTURA_TRONCO //* 0.8
#define LARGURA_COXA            LARGURA_QUADRIL / 3
//CANELA
#define JOELHO                  VIRILHA
#define ALTURA_CANELA           ALTURA_COXA * 0.75
#define LARGURA_CANELA          LARGURA_COXA * 0.7
//PE
#define TORNOZELO		ALTURA_TRONCO * 0.05
#define ALTURA_PE               TORNOZELO * 2.0
#define LARGURA_PE              LARGURA_CANELA * 0.9
#define PE                      LARGURA_PE * 2.0
//TRONCO
#define LARGURA_TRONCO          ALTURA_TRONCO * 0.4
#define ALTURA_TRONCO           0.75
#define TRONCO                  ALTURA_TRONCO * 0.5 / 1.75	//LARGURA_TRONCO / 1.75
#define SEIOS			ALTURA_TRONCO * 0.3
//BRACO
#define LARGURA_OMBRO           ALTURA_TRONCO * 0.33
#define ALTURA_OMBRO            LARGURA_OMBRO * 0.7
#define OMBRO                   LARGURA_OMBRO * 0.5
#define ALTURA_BRACO            ALTURA_TRONCO * 0.75
#define LARGURA_BRACO           ALTURA_TRONCO * 0.5 /4.0	//LARGURA_TRONCO/4.0
#define COTOVELO                LARGURA_OMBRO * 0.25
#define ALTURA_ANTEBRACO        ALTURA_BRACO * 0.8
#define LARGURA_ANTEBRACO       LARGURA_BRACO * 0.9
//MAO
#define ALTURA_MAO              ALTURA_ANTEBRACO / 3.0
#define LARGURA_MAO             LARGURA_ANTEBRACO
#define MAO                     LARGURA_ANTEBRACO / 2.0
#define DEDO                    0.1
//CABECA
#define LARGURA_CABECA          ALTURA_CABECA * 0.93
#define ALTURA_CABECA           ALTURA_TRONCO * 0.375
#define PESCOCO                 ALTURA_CABECA/2.5

//ORIGINAL
//#define TORNOZELO		PESCOCO
//#define ALTURA_PE		TORNOZELO * 2.0
//#define LARGURA_PE		LARGURA_CANELA
//#define PE			LARGURA_PE * 2.0
//#define ALTURA_BRACO		ALTURA_TRONCO * 0.625
//#define LARGURA_BRACO		LARGURA_TRONCO/4.0
//#define OMBRO			PESCOCO * 2.0
//#define ALTURA_ANTEBRACO        ALTURA_TRONCO * 0.5
//#define LARGURA_ANTEBRACO       LARGURA_BRACO
//#define COTOVELO		OMBRO * 0.75
//#define ALTURA_MAO		ALTURA_ANTEBRACO / 2.0
//#define LARGURA_MAO		LARGURA_ANTEBRACO
//#define MAO			LARGURA_ANTEBRACO / 2.0
//#define DEDO			0.1
//#define LARGURA_TRONCO	ALTURA_TRONCO * 0.75
//#define ALTURA_TRONCO		0.8
//#define TRONCO		LARGURA_TRONCO / 3.0
//#define LARGURA_CABECA          ALTURA_CABECA * 0.93
//#define ALTURA_CABECA 		ALTURA_TRONCO * 0.375
//#define PESCOCO			ALTURA_CABECA/6.0
//#define LARGURA_QUADRIL	LARGURA_TRONCO
//#define ALTURA_QUADRIL	ALTURA_TRONCO / 4.0
//#define ALTURA_COXA		ALTURA_ANTEBRACO
//#define VIRILHA		OMBRO
//#define LARGURA_COXA		VIRILHA * 2.0
//#define ALTURA_CANELA		ALTURA_COXA
//#define LARGURA_CANELA	LARGURA_COXA
//#define JOELHO		VIRILHA

#define ESQUERDA 0
#define DIREITA  1
#define SOLIDO	 1
#define ARAME	 2	
#define ANDAR    0
#define CORRER   1

#define QUADROS	 16

extern double movimento_base ;
extern float caminhar_angulos[2][6];
extern float	angulo_virilhaE ,
		angulo_joelhoE  ,
		angulo_virilhaD ,
		angulo_joelhoD  ,  
		angulo_quadril  ,
		angulo_tronco	;

extern float zoom ;
extern float impulso ;
extern int rotacao ;
extern int movimento;
extern int quadros ;
extern int frame_atual;
extern int quadro_atual;

double	calculaMovimentoBase(double angle_up, double angle_lo, double up, 
		double lo) ;
void	desenhaQuadrilPernas(void) ;
void	desenhaQuadril(int frame) ;
void	desenhaPerna(int side,int frame) ;

void	desenhaTroncoBracos(void);
void	desenhaTronco(int frame);
void	desenhaGrupoBraco(int side, int frame);
void	desenhaBraco(int side, int frame);
void	desenhaAntebraco(int frame);
void	desenhaMao(int frame);
void 	desenhaCabeca(int frame);

void	anima();
